# coding: utf-8

"""
    Metal API

    # Introduction Equinix Metal provides a RESTful HTTP API which can be reached at <https://api.equinix.com/metal/v1>. This document describes the API and how to use it.  The API allows you to programmatically interact with all of your Equinix Metal resources, including devices, networks, addresses, organizations, projects, and your user account. Every feature of the Equinix Metal web interface is accessible through the API.  The API docs are generated from the Equinix Metal OpenAPI specification and are officially hosted at <https://metal.equinix.com/developers/api>.  # Common Parameters  The Equinix Metal API uses a few methods to minimize network traffic and improve throughput. These parameters are not used in all API calls, but are used often enough to warrant their own section. Look for these parameters in the documentation for the API calls that support them.  ## Pagination  Pagination is used to limit the number of results returned in a single request. The API will return a maximum of 100 results per page. To retrieve additional results, you can use the `page` and `per_page` query parameters.  The `page` parameter is used to specify the page number. The first page is `1`. The `per_page` parameter is used to specify the number of results per page. The maximum number of results differs by resource type.  ## Sorting  Where offered, the API allows you to sort results by a specific field. To sort results use the `sort_by` query parameter with the root level field name as the value. The `sort_direction` parameter is used to specify the sort direction, either either `asc` (ascending) or `desc` (descending).  ## Filtering  Filtering is used to limit the results returned in a single request. The API supports filtering by certain fields in the response. To filter results, you can use the field as a query parameter.  For example, to filter the IP list to only return public IPv4 addresses, you can filter by the `type` field, as in the following request:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/projects/id/ips?type=public_ipv4 ```  Only IP addresses with the `type` field set to `public_ipv4` will be returned.  ## Searching  Searching is used to find matching resources using multiple field comparissons. The API supports searching in resources that define this behavior. The fields available for search differ by resource, as does the search strategy.  To search resources you can use the `search` query parameter.  ## Include and Exclude  For resources that contain references to other resources, sucha as a Device that refers to the Project it resides in, the Equinix Metal API will returns `href` values (API links) to the associated resource.  ```json {   ...   \"project\": {     \"href\": \"/metal/v1/projects/f3f131c8-f302-49ef-8c44-9405022dc6dd\"   } } ```  If you're going need the project details, you can avoid a second API request.  Specify the contained `href` resources and collections that you'd like to have included in the response using the `include` query parameter.  For example:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=projects ```  The `include` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests where `href` resources are presented.  To have multiple resources include, use a comma-separated list (e.g. `?include=emails,projects,memberships`).  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=emails,projects,memberships ```  You may also include nested associations up to three levels deep using dot notation (`?include=memberships.projects`):  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=memberships.projects ```  To exclude resources, and optimize response delivery, use the `exclude` query parameter. The `exclude` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests for fields with nested object responses. When excluded, these fields will be replaced with an object that contains only an `href` field.   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@equinixmetal.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from equinix_metal.models.capacity_level_per_baremetal import CapacityLevelPerBaremetal

class CapacityPerFacility(BaseModel):
    """
    CapacityPerFacility
    """
    baremetal_0: Optional[CapacityLevelPerBaremetal] = None
    baremetal_1: Optional[CapacityLevelPerBaremetal] = None
    baremetal_2: Optional[CapacityLevelPerBaremetal] = None
    baremetal_2a: Optional[CapacityLevelPerBaremetal] = None
    baremetal_2a2: Optional[CapacityLevelPerBaremetal] = None
    baremetal_3: Optional[CapacityLevelPerBaremetal] = None
    baremetal_s: Optional[CapacityLevelPerBaremetal] = None
    c2_medium_x86: Optional[CapacityLevelPerBaremetal] = Field(None, alias="c2.medium.x86")
    href: Optional[StrictStr] = None
    m2_xlarge_x86: Optional[CapacityLevelPerBaremetal] = Field(None, alias="m2.xlarge.x86")
    __properties = ["baremetal_0", "baremetal_1", "baremetal_2", "baremetal_2a", "baremetal_2a2", "baremetal_3", "baremetal_s", "c2.medium.x86", "href", "m2.xlarge.x86"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CapacityPerFacility:
        """Create an instance of CapacityPerFacility from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of baremetal_0
        if self.baremetal_0:
            _dict['baremetal_0'] = self.baremetal_0.to_dict()
        # override the default output from pydantic by calling `to_dict()` of baremetal_1
        if self.baremetal_1:
            _dict['baremetal_1'] = self.baremetal_1.to_dict()
        # override the default output from pydantic by calling `to_dict()` of baremetal_2
        if self.baremetal_2:
            _dict['baremetal_2'] = self.baremetal_2.to_dict()
        # override the default output from pydantic by calling `to_dict()` of baremetal_2a
        if self.baremetal_2a:
            _dict['baremetal_2a'] = self.baremetal_2a.to_dict()
        # override the default output from pydantic by calling `to_dict()` of baremetal_2a2
        if self.baremetal_2a2:
            _dict['baremetal_2a2'] = self.baremetal_2a2.to_dict()
        # override the default output from pydantic by calling `to_dict()` of baremetal_3
        if self.baremetal_3:
            _dict['baremetal_3'] = self.baremetal_3.to_dict()
        # override the default output from pydantic by calling `to_dict()` of baremetal_s
        if self.baremetal_s:
            _dict['baremetal_s'] = self.baremetal_s.to_dict()
        # override the default output from pydantic by calling `to_dict()` of c2_medium_x86
        if self.c2_medium_x86:
            _dict['c2.medium.x86'] = self.c2_medium_x86.to_dict()
        # override the default output from pydantic by calling `to_dict()` of m2_xlarge_x86
        if self.m2_xlarge_x86:
            _dict['m2.xlarge.x86'] = self.m2_xlarge_x86.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CapacityPerFacility:
        """Create an instance of CapacityPerFacility from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CapacityPerFacility.parse_obj(obj)

        _obj = CapacityPerFacility.parse_obj({
            "baremetal_0": CapacityLevelPerBaremetal.from_dict(obj.get("baremetal_0")) if obj.get("baremetal_0") is not None else None,
            "baremetal_1": CapacityLevelPerBaremetal.from_dict(obj.get("baremetal_1")) if obj.get("baremetal_1") is not None else None,
            "baremetal_2": CapacityLevelPerBaremetal.from_dict(obj.get("baremetal_2")) if obj.get("baremetal_2") is not None else None,
            "baremetal_2a": CapacityLevelPerBaremetal.from_dict(obj.get("baremetal_2a")) if obj.get("baremetal_2a") is not None else None,
            "baremetal_2a2": CapacityLevelPerBaremetal.from_dict(obj.get("baremetal_2a2")) if obj.get("baremetal_2a2") is not None else None,
            "baremetal_3": CapacityLevelPerBaremetal.from_dict(obj.get("baremetal_3")) if obj.get("baremetal_3") is not None else None,
            "baremetal_s": CapacityLevelPerBaremetal.from_dict(obj.get("baremetal_s")) if obj.get("baremetal_s") is not None else None,
            "c2_medium_x86": CapacityLevelPerBaremetal.from_dict(obj.get("c2.medium.x86")) if obj.get("c2.medium.x86") is not None else None,
            "href": obj.get("href"),
            "m2_xlarge_x86": CapacityLevelPerBaremetal.from_dict(obj.get("m2.xlarge.x86")) if obj.get("m2.xlarge.x86") is not None else None
        })
        return _obj

