# coding: utf-8

"""
    Metal API

    # Introduction Equinix Metal provides a RESTful HTTP API which can be reached at <https://api.equinix.com/metal/v1>. This document describes the API and how to use it.  The API allows you to programmatically interact with all of your Equinix Metal resources, including devices, networks, addresses, organizations, projects, and your user account. Every feature of the Equinix Metal web interface is accessible through the API.  The API docs are generated from the Equinix Metal OpenAPI specification and are officially hosted at <https://metal.equinix.com/developers/api>.  # Common Parameters  The Equinix Metal API uses a few methods to minimize network traffic and improve throughput. These parameters are not used in all API calls, but are used often enough to warrant their own section. Look for these parameters in the documentation for the API calls that support them.  ## Pagination  Pagination is used to limit the number of results returned in a single request. The API will return a maximum of 100 results per page. To retrieve additional results, you can use the `page` and `per_page` query parameters.  The `page` parameter is used to specify the page number. The first page is `1`. The `per_page` parameter is used to specify the number of results per page. The maximum number of results differs by resource type.  ## Sorting  Where offered, the API allows you to sort results by a specific field. To sort results use the `sort_by` query parameter with the root level field name as the value. The `sort_direction` parameter is used to specify the sort direction, either either `asc` (ascending) or `desc` (descending).  ## Filtering  Filtering is used to limit the results returned in a single request. The API supports filtering by certain fields in the response. To filter results, you can use the field as a query parameter.  For example, to filter the IP list to only return public IPv4 addresses, you can filter by the `type` field, as in the following request:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/projects/id/ips?type=public_ipv4 ```  Only IP addresses with the `type` field set to `public_ipv4` will be returned.  ## Searching  Searching is used to find matching resources using multiple field comparissons. The API supports searching in resources that define this behavior. The fields available for search differ by resource, as does the search strategy.  To search resources you can use the `search` query parameter.  ## Include and Exclude  For resources that contain references to other resources, sucha as a Device that refers to the Project it resides in, the Equinix Metal API will returns `href` values (API links) to the associated resource.  ```json {   ...   \"project\": {     \"href\": \"/metal/v1/projects/f3f131c8-f302-49ef-8c44-9405022dc6dd\"   } } ```  If you're going need the project details, you can avoid a second API request.  Specify the contained `href` resources and collections that you'd like to have included in the response using the `include` query parameter.  For example:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=projects ```  The `include` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests where `href` resources are presented.  To have multiple resources include, use a comma-separated list (e.g. `?include=emails,projects,memberships`).  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=emails,projects,memberships ```  You may also include nested associations up to three levels deep using dot notation (`?include=memberships.projects`):  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=memberships.projects ```  To exclude resources, and optimize response delivery, use the `exclude` query parameter. The `exclude` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests for fields with nested object responses. When excluded, these fields will be replaced with an object that contains only an `href` field.   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@equinixmetal.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import absolute_import

import unittest

import equinix_metal
from equinix_metal.api.ports_api import PortsApi  # noqa: E501
from equinix_metal.rest import ApiException


class TestPortsApi(unittest.TestCase):
    """PortsApi unit test stubs"""

    def setUp(self):
        self.api = equinix_metal.api.ports_api.PortsApi()  # noqa: E501

    def tearDown(self):
        pass

    def test_assign_native_vlan(self):
        """Test case for assign_native_vlan

        Assign a native VLAN  # noqa: E501
        """
        pass

    def test_assign_port(self):
        """Test case for assign_port

        Assign a port to virtual network  # noqa: E501
        """
        pass

    def test_bond_port(self):
        """Test case for bond_port

        Enabling bonding  # noqa: E501
        """
        pass

    def test_convert_layer2(self):
        """Test case for convert_layer2

        Convert to Layer 2  # noqa: E501
        """
        pass

    def test_convert_layer3(self):
        """Test case for convert_layer3

        Convert to Layer 3  # noqa: E501
        """
        pass

    def test_create_port_vlan_assignment_batch(self):
        """Test case for create_port_vlan_assignment_batch

        Create a new Port-VLAN Assignment management batch  # noqa: E501
        """
        pass

    def test_delete_native_vlan(self):
        """Test case for delete_native_vlan

        Remove native VLAN  # noqa: E501
        """
        pass

    def test_disbond_port(self):
        """Test case for disbond_port

        Disabling bonding  # noqa: E501
        """
        pass

    def test_find_port_by_id(self):
        """Test case for find_port_by_id

        Retrieve a port  # noqa: E501
        """
        pass

    def test_find_port_vlan_assignment_batch_by_port_id_and_batch_id(self):
        """Test case for find_port_vlan_assignment_batch_by_port_id_and_batch_id

        Retrieve a VLAN Assignment Batch's details  # noqa: E501
        """
        pass

    def test_find_port_vlan_assignment_batches(self):
        """Test case for find_port_vlan_assignment_batches

        List the VLAN Assignment Batches for a port  # noqa: E501
        """
        pass

    def test_find_port_vlan_assignment_by_port_id_and_assignment_id(self):
        """Test case for find_port_vlan_assignment_by_port_id_and_assignment_id

        Show a particular Port VLAN assignment's details  # noqa: E501
        """
        pass

    def test_find_port_vlan_assignments(self):
        """Test case for find_port_vlan_assignments

        List Current VLAN assignments for a port  # noqa: E501
        """
        pass

    def test_unassign_port(self):
        """Test case for unassign_port

        Unassign a port  # noqa: E501
        """
        pass


if __name__ == '__main__':
    unittest.main()
